(*
 To run this file:
    ocaml
    #use "3_types.ml";; 
*)

let rec sum l = match l with
    [] -> 0
  | (x :: rest) -> x + (sum rest)

(* 
let s0 = sum [];;
let s1 = sum [1; 2; 3];;
let s2 = sum [1; 5; 1; 1; 2];;
 *)

let rec multiplyAdjacent l = match l with
    [] -> []
  | [x] -> [x]
  | (x::y::rest) -> (x * y)::(multiplyAdjacent rest)

(* 
let a1 = multiplyAdjacent []
let a2 = multiplyAdjacent [6; 4; 5; 9; 7]
let a3 = multiplyAdjacent [1; 2; 3; 4; 5; 6; 7; 8]
*)

let rec minList (l : int list) : int option = match l with
    [] -> None
  | (x :: rest) -> (match minList rest with
                      None -> Some x
                    | (Some y) -> Some (if x < y then x else y))

(* 
let m1 = minList []
let m2 = minList [3; 6; 9]
let m3 = minList [15; 1; 12]
let m4 = minList [-23; 1; -62; -51; 67; 53; 49; 1; 92; -96]
*)

type point = Origin 
           | Polar of float * float 
           | Cartesian of float * float
           | Midpoint of point * point

let rec distance (p : point) : float = match p with
    Origin -> 0.0
  | Polar (radius, _) -> radius
  | Cartesian (x, y) -> Float.sqrt (x *. x +. y *. y)
  | Midpoint (p1, p2) -> ((distance p1) +. (distance p2)) /. 2.0

(* 
let p1 = Origin
let p2 = Polar (4.5, 2.1)
let p3 = Cartesian (3.0, 4.0)
let p4 = Midpoint (p1, p3)

let d1 = distance p1
let d2 = distance p2
let d3 = distance p3
let d4 = distance p4
*)