(*
 To run this file:
    ocaml
    #use "6_demo.ml";; 
*)

type storage = File of string * int
             | Folder of string * (storage list)

let rec listFiles s = match s with
    File (name, size) -> [name]
  | Folder (name, contents) -> 
      let subLists = List.map listFiles contents in
      let combined = List.fold_left (fun x y -> x @ y) [] subLists in
      let prefixed = List.map (fun x -> name ^ "/" ^ x) combined in
      prefixed

let fi1 = File ("Hello.py", 42)
let fi2 = File ("World.cpp", 100)
let fi3 = File ("Yay.txt", 15)
let fi4 = File ("Foo.txt", 112)
let fo1 = Folder("B", [fi1; fi2])
let fo2 = Folder("C", [fi4])
let fo3 = Folder("A", [fo1; fi3; fo2])
let paths = listFiles fo3